#include <stdio.h>
#include <string.h>
#include "database.h"

void dbs_test()
{
    char str[1024];
    char name[MAX_DBS_NAME_LEN];
    char key[MAX_DBS_KEY_LEN];
    char value[MAX_DBS_VALUE_LEN];
    int i;

    dbs_init();
    while (gets(str))
    {
	if (strcmp(str, "quit") == 0)
	    break;
	if (strcmp(str, "exit") == 0)
	    break;
	if (strcmp(str, "create") == 0)
	{
	    dbs_create(str);
	    printf("%s\n", str);
	}
	if (strncmp(str, "set ", 4) == 0)
	{
	    strcpy(name, &str[4]);
	}
	if (strncmp(str, "get ", 4) == 0)
	{
	    strcpy(key, &str[4]);
	    if (dbs_get(name, key, value) == DBS_SUCCESS)
		printf("%s\n", value);
	    else
		printf("DBS_FAIL\n");
	}
	if (strncmp(str, "put ", 4) == 0)
	{
	    i = 4;
	    key[0] = '\0';
	    while (str[i] != '\0')
	    {
		if (str[i] == ':')
		{
		    key[i-4] = '\0';
		    strcpy(value, &str[i+1]);
		    if (dbs_put(name, key, value) == DBS_SUCCESS)
			printf("DBS_SUCCESS\n");
		    else
			printf("DBS_FAIL\n");
		    break;
		}
		key[i-4] = str[i];
		i++;
	    }
	}
	if (strcmp(str, "print") == 0)
	{
	    dbs_first(name, key, value);
	    while (key[0] != '\0')
	    {
		printf("%s:%s:%s\n", name, key, value);
		dbs_next(name, key, value);
	    }
	}
	if (strcmp(str, "destroy") == 0)
	{
	    if (dbs_destroy(name) == DBS_SUCCESS)
		printf("DBS_SUCCESS\n");
	    else
		printf("DBS_FAIL\n");
	}
	if (strncmp(str, "delete ", 7) == 0)
	{
	    strcpy(key, &str[7]);
	    if (dbs_delete(name, key) == DBS_SUCCESS)
		printf("DBS_SUCCESS\n");
	    else
		printf("DBS_FAIL\n");
	}
	if (strcmp(str, "dbs") == 0)
	{
	    dbs_firstdb(str);
	    while (str[0] != '\0')
	    {
		printf("%s\n", str);
		dbs_nextdb(str);
	    }
	}
    }
    dbs_finalize();
}

int main(int argc, char *argv[])
{
    printf("running database test\nEnter commands\n");
    dbs_test();
    return 0;
}
